/* Java */

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;

public class boxes {

	private static String INPUT_FILE = "boxes.in";
	private static String OUTPUT_FILE = "boxes.out";
	
	private static BufferedReader in;
	private static BufferedWriter out;
	
	private static int boxes = 0;
	private static int[] arr;
	private static boolean[][] hasCache;
	private static int[][] routeCache;
	
	public static void solve() throws Exception {
		String[] spl = in.readLine().split(" ");
		boxes = Integer.parseInt(spl[0]);
		int schools = Integer.parseInt(spl[1]);
		arr = new int[schools];
		hasCache = new boolean[schools][boxes];
		routeCache = new int[schools][boxes];
		for (int i = 0; i < schools; i++) {
			arr[i] = Integer.parseInt(in.readLine());
		}
		
		out.append(Integer.toString(count(0, 0)));
		out.append("\n");
	}
	
	public static int count(int k, int boxesGiven) {
		if (k >= arr.length) {
			return 0;
		} else if (boxesGiven > boxes) {
			return 0;
		} else if (hasCache[k][boxesGiven]) {
			return routeCache[k][boxesGiven];
		} else if (k == arr.length - 1) {
			if (boxesGiven + arr[k] <= boxes) {
				return 1;
			} else {
				return 0;
			}
		}
		
		int result = 0;
		int countLeft = count(k + 1, boxesGiven);
		int countRight = count(k+1, boxesGiven + arr[k]) + 1;
		
		if (countRight > countLeft) {
			result = countRight;
		} else {
			result = countLeft;
		}
		
		hasCache[k][boxesGiven] = true;
		routeCache[k][boxesGiven] = result;
		
		return result;
	}
	
	public static void main(String[] args) {
		try {
			in = new BufferedReader(new FileReader(new File(INPUT_FILE)));
			out = new BufferedWriter(new FileWriter(new File(OUTPUT_FILE)));
			solve();
			out.flush();
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
}
