/* */
#include <iostream>
#include <fstream>
using namespace std;

struct Point {
    int x;
    int y;
    Point (int _x, int _y) {x = _x; y = _y;}
    Point () {x = y = 0;}
};

struct Rect {
    Point p1, p2;
    long id;
    Rect (Point _p1, Point _p2, long _id) {p1 = _p1; p2 = _p2; id = _id;}
    Rect () { p1 = Point(); p2 = Point(); id=-1; }
    bool intersects(Rect r) {
//        for (long x=p1.x; x<=p2.x; x++) {
//            for (long y=p1.y; y<=p2.y; y++) {
//                if ( x >= r.p1.x && x <= r.p2.x && y >= r.p1.y && y <= r.p2.y ) return true;
//            }
//        }
//        return false;
        return (r.has(p1) || r.has(p2) || has(r.p1) || has(r.p2));
    }
    bool has(Point p) {
        return (p.x >= p1.x && p.x <= p2.x && p.y >= p1.y && p.y <= p2.y);
    }
};

int main()
{
    int H, W;
    long Q;
    ifstream in("football.in");
    in.sync_with_stdio(false);
    in >> H >> W >> Q;
    Rect R[Q];
    for (long i=0; i<Q; i++) {
        Rect input;
        in >> input.p1.x >> input.p1.y;
        in >> input.p2.x >> input.p2.y;
        input.id = i;
        R[i] = input;
    }
    in.close();

    unsigned long Z = 0;

    for (long i=0; i<Q; i++) {
        for (long j=i+1; j<Q; j++) {
            if (R[i].intersects(R[j])) Z++;
        }
    }

    ofstream out("football.out");
    out << Z;
    out.close();


    return 0;
}
