#include <iostream>
#include <cstdio>
#include <algorithm>
#include <set>

using namespace std;

struct qvarta
{
    long long xx, xy, yx, yy;
};

const int mod = 1e9+7;

long long pow2(int k)
{
    long long res = 1;
    while (k > 0){
        --k;
        res = (res*2) % mod;
    }
    return res;
}


long long fT(int N, int C)
{
    if (C >= N) return pow2(N);
    long long res = 0;
    res = (res + fT(N-1, C))%mod;
    for (int i = 2; i <= C+1; ++i){
        res = (res + fT(N-i, C))%mod;
    }
    return res;
}

qvarta matr(int n)
{
    if (n == 1) return {1, 1, 1, 0};
    if (n % 2 == 0){
        qvarta M = matr(n/2);
        long long a = M.xx, b = M.xy, c = M.yx, d = M.yy;
        return { (a*a%mod + b*c%mod)%mod, (a*b%mod+b*d%mod)%mod, (a*b%mod+b*d%mod)%mod, (d*d%mod+b*c%mod)%mod};
    }
    qvarta M = matr(n-1);
    long long a = M.xx, b = M.xy, c = M.yx, d = M.yy;
    return {(a+b)%mod, (c+d)%mod, (c+d)%mod, c%mod};
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio();
    freopen("radioactive.in", "r", stdin);
    freopen("radioactive.out", "w", stdout);

    long long N, C;
    cin >> N >> C;
    if (C == 1){
        qvarta M = matr(N+1);
        cout << M.xx;
    }
    else{
        cout << fT(N, C);
    }

    return 0;
}
