#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
#define die(x) { cout << (x); exit(0); }
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)

using namespace std;
typedef long long lint;
typedef pair<int, int> pii;
const lint inf = 1000*1000*1000 + 7;

typedef vector<lint> row;
typedef vector<row> mat;

mat operator * (const mat& a, const mat& b) {
    int n = a.size();
    mat res(n, row(n, 0));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            for (int k = 0; k < n; k++)
                res[i][j] = (res[i][j] + a[i][k]*b[k][j]) % inf;
    return res;
}

void fill_mat(mat& a, lint n) {
    a.assign(n, row(n, 0));
    for (int i = 0; i < n; i++)
        a[i][0] = 1;
    for (int i = 0; i < n-1; i++)
        a[i][i+1] = 1;
}

void start_mat(mat& a, lint n) {
    a.assign(n, row(n, 0));
    for (int i = 0; i < n; i++)
        a[i][n-1-i] = 1;
    for (int i = 0; i < n-1; i++) {
        lint two = 1;
        for (int j = n-2-i; j >= 0; j--) {
            a[i][j] = two;
            two = (two << 1) % inf;
        }
    }
}

void print(const mat& a) {
    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < a.size(); j++)
            cout << a[i][j] << ' ';
        cout << '\n';
    }
}

mat binpow(mat& a, lint n) {
    mat res;
    res.assign(a.size(), row(a.size(), 0));
    for (int i = 0; i < a.size(); i++)
        res[i][i] = 1;
    while (n) {
        if (n & 1) res = res*a;
        a = a*a;
        n >>= 1;
    }
    return res;
}

int solve(lint n, lint c) {
    mat a, b;
    start_mat(a, c);
    fill_mat(b, c);
    mat res = a*binpow(b, n);
    return res[0][0];
}

int main() {
    files(radioactive);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    lint n, c;
    cin >> n >> c;
    if (n <= c) {
        lint res = 1, a = 2;
        while (n) {
            if (n & 1) res = res*a % inf;
            a = a*a % inf;
            n >>= 1;
        }
        cout << res;
        return 0;
    }
    cout << solve(n-c+1, c+1);

    return 0;
}
