/* GCC */

#include<fstream>
#include<iostream>

using namespace std;

const long long mod = 1e9+7;

long long n, c;

struct matrix{
    matrix(){
        for(int i = 0; i <= c; i++){
            for(int j = 0; j <= c; j++){
                data[i][j] = 0;
            }
        }
    }
    matrix(const matrix& m){
        for(int i = 0; i <= c; i++){
            for(int j = 0; j <= c; j++){
                data[i][j] = m.data[i][j];
            }
        }
    }
    matrix operator*=(const matrix& m){
        for(int i = 0; i <= c; i++){
            long long r[201];
            for(int j = 0; j <= c; j++){
                for(int k = 0; k <= c; k++){
                    r[k] += data[i][j] * m.data[j][k];
                    r[k] %= mod;
                }
            }
            for(int j = 0; j <= c; j++){
                this->data[i][j] = r[j];
            }
        }
        return *this;
    }
    long long data[201][201];
};

int main(){
    ifstream in;
    in.open("radioactive.in");
    ofstream out;
    out.open("radioactive.out");

    in >> n >> c;
    matrix startm;
    for(int i = 0; i <= c; i++){
        startm.data[0][i] = 1;
        startm.data[i+1][i] = 1;
    }
    long long s = 1;
    matrix resultm;
    for(int i = 0; i <= c; i++){
        resultm.data[i][i] = 1;
    }
    while(s <= n){
        if(s & n){
            resultm *= startm;
        }
        startm *= startm;
        s <<= 1;
    }
    long long sum = 0;
    for(int i = 0; i <= c; i++){
        sum = (sum + resultm.data[i][0]) % mod;
    }
    out << sum << endl;

    out.close();
    in.close();
}


